import { isCoValueClass, } from "../internal.js";
/** @category Schema definition */
export const co = {
    string: {
        [SchemaInit]: "json",
    },
    number: {
        [SchemaInit]: "json",
    },
    boolean: {
        [SchemaInit]: "json",
    },
    null: {
        [SchemaInit]: "json",
    },
    literal(..._lit) {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return { [SchemaInit]: "json" };
    },
    json() {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return { [SchemaInit]: "json" };
    },
    encoded(arg) {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return { [SchemaInit]: { encoded: arg } };
    },
    ref,
    items: ItemsSym,
    members: MembersSym,
};
function ref(arg, options) {
    return {
        [SchemaInit]: {
            ref: arg,
            optional: options?.optional || false,
        },
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
    };
}
export function isRefEncoded(schema) {
    return (typeof schema === "object" &&
        "ref" in schema &&
        "optional" in schema &&
        typeof schema.ref === "function");
}
export function instantiateRefEncoded(schema, raw) {
    return isCoValueClass(schema.ref)
        ? schema.ref.fromRaw(raw)
        : schema.ref(raw).fromRaw(raw);
}
import { Date } from "@effect/schema/Schema";
import { SchemaInit, ItemsSym, MembersSym } from "./symbols.js";
/** @category Schema definition */
export const Encoders = {
    Date,
};
//# sourceMappingURL=schema.js.map